#ifnexists Testing_Autoload
public variable Testing_Autoload = 1;
_debug_info = 1; () = evalfile ("inc.sl");
print ("Testing autoload ...");

public variable Num_Foo_Loads = 0;
public variable Num_Foo_Args = 0;

autoload ("foo", __FILE__);	       %  load foo into the global namespace
if (0 == is_defined ("foo"))
  failed ("autoload foo 1");

autoload ("ns2->foo", __FILE__);	       %  load foo into ns2

implements ("ns1");
# iffalse
% I want to add private namespaces before I allow this to be implicitly
% be loaded into the current namespace
autoload ("foo", __FILE__);
# else
autoload ("ns1->foo", __FILE__);
# endif
% Now foo should be define in ns1, as well as in the global
if (0 == is_defined ("ns1->foo"))
  failed ("autoload ns1->foo");

$1 = Global->foo (1,2,3);
if (Num_Foo_Loads != 1)
  failed ("Failed to load foo into the global namespace: %d", Num_Foo_Loads);
if (Num_Foo_Args != 3)
  failed ("_NARGS not 3 in autoloaded function");

if ($1 == "Global")
  failed ("Global namespace was used for private objects");

() = ns1->foo (1,2,3,4);
if (Num_Foo_Loads != 2)
  failed ("Failed to load foo into ns1");
if (Num_Foo_Args != 4)
  failed ("_NARGS not 4 in autoloaded function");

() = ns2->foo ();
if (Num_Foo_Loads != 3)
  failed ("Failed to load foo into ns2");
if (Num_Foo_Args != 0)
  failed ("_NARGS not 0 in autoloaded function");

() = evalfile (__FILE__, "ns3");
if (0 == is_defined ("ns3->foo"))
  failed ("ns3->foo is not defined");

if ("ns3" != ns3->foo())
  failed ("ns3->foo returned %s", ns3->foo ());
if ("ns2" != ns2->foo())
  failed ("ns2->foo returned %s", ns2->foo ());
if ("ns1" != ns1->foo())
  failed ("ns1->foo returned %s", ns1->foo ());

print ("Ok\n");
exit (0);
#else
private variable My_Namespace = current_namespace ();
Num_Foo_Loads++;
define foo ()
{
   _pop_n (_NARGS);
   Num_Foo_Args = _NARGS;
   return My_Namespace;
}
() = foo (1,2,3,4,5);
#endif
